\section{Description Logics}
Deals with Relations between classes like subsumption.
The entities provided by the logic are
\begin{itemize}
  \item \textbf{Individuals}
  \item \textbf{Concept}:
    Corresponding to unary predicates such as $\operatorname{Father} (x), \operatorname{Knife}(x)$, etc.
    Simliar to sets

  \item \textbf{Roles}:
    Corresponding to relational (binary) predicates such as $\operatorname{Age}(x, age)$,
    $\operatorname{FatherOf} (x,y)$, \dots
\end{itemize}

The semantics is defined w.r.t. an interpretation $I = \langle D,\Phi\rangle$, such that
$\Phi(i)\in D$ (individuals), $\Phi(c) \subseteq D$ (concepts), $\Phi(r) \subseteq D\times D$ (roles).

From these entities new concepts can be build as follows (for roles $r$, individual $i$,
naturals $n\in\mathbb N_+$,
and concepts $c$):
\begin{itemize}
  \item \textbf{(\texttt{ALL} $r$ $c$)}:
    All the concepts that are only in relation $r$ with individuals in $c$

  \item \textbf{(\texttt{AT-LEAST} $n$ $r$)}:
    There are at least $n$ role-fillers for every individual in this concept

  \item \textbf{(\texttt{FILLS} $r$ $i$)}: Every individual in this concept is in relation $r$ with individual $i$

  \item \textbf{(\texttt{AND} $c_1$ \ldots\, $c_n$)}
\end{itemize}

From these concepts sentences that constitute a KB can be build:
\begin{itemize}
  \item \textbf{Definition}: $c_1 \doteq c_2$
  \item \textbf{Partial Assertions}: $c_1 \sqsubseteq c_2$
  \item \textbf{Satisfaction}: $const \rightarrow c$ for constant $const$, i.e. $\Phi(const) \in \Phi(c)$
\end{itemize}

\subsection{Normalisation}
\begin{enumerate}
  \item \textbf{Flatten \textbf{AND}s}:
    \[\texttt{(AND (AND \dots)} \longrightarrow \texttt{(AND \dots)}\]

  \item \textbf{Push \textbf{AND}s inside role restrictions}:
    \[\texttt{(AND (ALL $r$ $c_1$) (ALL $r$ $c_2$))} \longrightarrow \texttt{(ALL $r$ (AND $c_1$ $c_2$))} \]

  \item \textbf{Remove redundant descriptors}:
    \begin{align*}
      \texttt{(AND (AT-LEAST $2$ $r$) (AT-LEAST $4$ $r$))} &\longrightarrow \texttt{(AT-LEAST $2$ $r$)} \\
      \texttt{(AT-LEAST $0$ $r$)} &\longrightarrow \texttt{THING}
    \end{align*}

  \item \textbf{Combine Different Operators}:
    \[\texttt{(AND (AT-LEAST $2$ $r$) (AT-MOST $1$ $r$))} \longrightarrow \texttt{NOTHING}\]

  \item \textbf{Replace Equivalent Forms with Canonical Forms}:
    \begin{align*}
      \texttt{(AND (\dots\, NOTHING))} &\longrightarrow \texttt{NOTHING} \\
      \texttt{(ALL $r$ NOTHING)} &\longrightarrow \texttt{(AT-MOST 0 $r$)}
    \end{align*}
\end{enumerate}

After normalisation the term is \texttt{(AND $constr_1$ \ldots $constr_n$)} where $constr_i$ is a role constraint.

\subsection{Entailment}
The validity of entailment $c_1 \sqsubseteq c_2$ can then be computed by structure matching.
For input $d\sqsubseteq e$ let $d = \texttt{(AND $d_1$ \ldots\, $d_m$)}$,
and $e = \texttt{$e_1$ \ldots\, $e_{m'}$}$.
Then for each $e_j$ check if there is a $d_i$ such that

\begin{enumerate}
  \item Both concepts are atomic and identical, or
  \item if $e_j = \texttt{(FILLS $r$ $i$)}$ then $d_i$ is identical to $d_j$
  \item if $e_j = \texttt{(AT-LEAST $n$ $r$)}$ then $d_i = \texttt{(AT-LEAST $n'$ $r$)}$ with $n'\geq n$,
    or if $n=1$ then $d_i = \texttt{(FILLS $r$ $c$)}$ for any constant $c$ is also possible
  \item if $e_j = \texttt{(ALL $r$ $e'$)}$ then $d_i = \texttt{(ALL $r$ $d'$)}$ with $d'\sqsubseteq e'$
\end{enumerate}

This algorithm is sound, and complete if the KB the terms do not contain \texttt{(AT-MOST \ldots)}.
